#ifndef NGHOSTCLIENT_CONFIGURATION_NGHOSTCLIENTCONFIGURATIONPROPERTY_PROTECT
#define NGHOSTCLIENT_CONFIGURATION_NGHOSTCLIENTCONFIGURATIONPROPERTY_PROTECT

// -------------------------------------------------------------------
// enum NGhostClient::Configuration::NGhostClientConfigurationProperty
// -------------------------------------------------------------------

typedef enum NGhostClientConfigurationProperty
{
	// Device properties
	NGHOST_CLIENT_CONFIGURATION_PROPERTY_DEVICE_NAME,

	// Authentication properties
	NGHOST_CLIENT_CONFIGURATION_PROPERTY_AUTHENTICATION_USERNAME,
	NGHOST_CLIENT_CONFIGURATION_PROPERTY_AUTHENTICATION_PASSWORD,
	NGHOST_CLIENT_CONFIGURATION_PROPERTY_IS_AUTHENTICATION_MANAGER_DATA_PERSISTENT,

	// Network
	NGHOST_CLIENT_CONFIGURATION_PROPERTY_NETWORK_LISTENING_INTERFACE,
	NGHOST_CLIENT_CONFIGURATION_PROPERTY_NETWORK_LISTENING_PORT,
	NGHOST_CLIENT_CONFIGURATION_PROPERTY_NETWORK_TOKEN_DELIVERY_TRUSTED_IP,

	// Scanner
	NGHOST_CLIENT_CONFIGURATION_PROPERTY_SCANNER_INTERFACE_FILTER,
	NGHOST_CLIENT_CONFIGURATION_PROPERTY_SCANNER_THREAD_COUNT,
	NGHOST_CLIENT_CONFIGURATION_PROPERTY_SCANNER_CONNECTION_TIMEOUT,
	NGHOST_CLIENT_CONFIGURATION_PROPERTY_SCANNER_REQUEST_TIMEOUT,
	NGHOST_CLIENT_CONFIGURATION_PROPERTY_SCANNER_USER_ADDRESS,
	NGHOST_CLIENT_CONFIGURATION_PROPERTY_SCANNER_TYPE_FILTER,
	NGHOST_CLIENT_CONFIGURATION_PROPERTY_SCANNER_UUID_FILTER,

	NGHOST_CLIENT_CONFIGURATION_PROPERTIES
} NGhostClientConfigurationProperty;

// Defaults configuration values
#define NGHOST_CLIENT_CONFIGURATION_PROPERTY_DEVICE_DEFAULT_NAME												"ToBeSet"
#define NGHOST_CLIENT_CONFIGURATION_PROPERTY_AUTHENTICATION_DEFAULT_USERNAME									"test"
#define NGHOST_CLIENT_CONFIGURATION_PROPERTY_AUTHENTICATION_DEFAULT_PASSWORD									"test"
#define NGHOST_CLIENT_CONFIGURATION_PROPERTY_AUTHENTICATION_DEFAULT_IS_AUTHENTICATION_MANAGER_DATA_PERSISTENT	NTRUE
#define NGHOST_CLIENT_CONFIGURATION_PROPERTY_NETWORK_DEFAULT_LISTENING_INTERFACE								"*"
#define NGHOST_CLIENT_CONFIGURATION_PROPERTY_NETWORK_DEFAULT_LISTENING_PORT										NDEVICE_COMMON_TYPE_GHOST_CLIENT_LISTENING_PORT
#define NGHOST_CLIENT_CONFIGURATION_PROPERTY_NETWORK_TOKEN_DELIVERY_TRUSTED_IP_DEFAULT							""
#define NGHOST_CLIENT_CONFIGURATION_PROPERTY_SCANNER_DEFAULT_INTERFACE_FILTER									"lo"
#define NGHOST_CLIENT_CONFIGURATION_PROPERTY_SCANNER_DEFAULT_THREAD_COUNT										50
#define NGHOST_CLIENT_CONFIGURATION_PROPERTY_SCANNER_DEFAULT_CONNECTION_TIMEOUT									800
#define NGHOST_CLIENT_CONFIGURATION_PROPERTY_SCANNER_DEFAULT_REQUEST_TIMEOUT									2500
#define NGHOST_CLIENT_CONFIGURATION_PROPERTY_SCANNER_DEFAULT_USER_ADDRESS										""
#define NGHOST_CLIENT_CONFIGURATION_PROPERTY_SCANNER_DEFAULT_TYPE_FILTER										""
#define NGHOST_CLIENT_CONFIGURATION_PROPERTY_SCANNER_DEFAULT_UUID_FILTER										""

/**
 * Get key set
 *
 * @return the key set
 */
__ALLOC char **NGhostClient_Configuration_NGhostClientConfigurationProperty_GetKeySet( void );

/**
 * Get key
 *
 * @param key
 * 		The key to get
 *
 * @return the key
 */
const char *NGhostClient_Configuration_NGhostClientConfigurationProperty_GetKey( NGhostClientConfigurationProperty key );

#ifdef NGHOSTCLIENT_CONFIGURATION_NGHOSTCLIENTCONFIGURATIONPROPERTY_INTERNE
static const char NGhostClientConfigurationPropertyText[ NGHOST_CLIENT_CONFIGURATION_PROPERTIES ][ 64 ] =
{
	"deviceName:",

	"username:",
	"password:",
	"isAuthenticationManagerDataPersistent:",

	"listenOnIP:",
	"listenOnPort:",
	"trustedTokenIP:",

	"scannerInterfaceFilter:",
	"scannerThreadCount:",
	"scannerConnectionTimeout:",
	"scannerRequestTimeout:",
	"scannerUserAddress:",
	"scannerTypeFilter:",
	"scannerUUIDFilter:"
};
#endif // NGHOSTCLIENT_CONFIGURATION_NGHOSTCLIENTCONFIGURATIONPROPERTY_INTERNE

#endif // !NGHOSTCLIENT_CONFIGURATION_NGHOSTCLIENTCONFIGURATIONPROPERTY_PROTECT
